//+-------------------------------------------------------------------+
//|                                            Bollinger Bands %b.mq4 |
//|                           Original indicator by Alejandro Galindo |
//|                  Modified and Corrected by Linuxser for forex TSD |
//|                                                                   |
//| John Bollinger original formula is:                               |
//| (Last - Lower BB)/(Upper BB - Lower BB)                           |
//+-------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 DodgerBlue
#property indicator_color3 Snow


//---- input parameters
extern int BBPeriod=21;
extern int StdDeviation=2;
extern string s1 = "0=Close,1=Open,2=High,3=Low,4=Median,5=Typical,6=Weighted";
extern int    AppliedPrice=5;
extern string s2 = "0=SMA,1=EMA,2=Smoothed,4=LWMA";  
extern int    BollingerMAMethod=1;
extern int    SmoothingMAMethod=1;
extern int    SmoothingMAPeriod=2;

//---- buffers
double BLGBuffer[];
double Buffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,BLGBuffer);
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,Buffer1);
   
   //SetLevelValue(1,10);
   SetLevelValue(0,0);
   SetLevelValue(1,20);
   SetLevelValue(2,40);
   SetLevelValue(3,60);
   SetLevelValue(4,80);
   SetLevelValue(5,100);
   SetLevelStyle(STYLE_DOT,1,DimGray);
   
   //name for DataWindow and indicator subwindow label
   short_name="Bollinger Percent B (%b)("+BBPeriod+","+StdDeviation+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   
   SetIndexDrawBegin(0,BBPeriod);
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Momentum                                                         |
//+------------------------------------------------------------------+
int start() {
   int i, limit;
   //number of bars already processed by indicator
   int counted_bars=IndicatorCounted();
  
   //initialize the array to zero on first use
   if(counted_bars<1) for(i=1;i<=BBPeriod;i++) BLGBuffer[Bars-i]=0.0;
   //i = number of bars to process
   limit=Bars-BBPeriod-1;
   if(counted_bars>=BBPeriod) limit=Bars-counted_bars-1;
   
   for(i = limit; i >= 0 ; i--) {  
      //(Last - Lower BB)/(Upper BB - Lower BB)      
      BLGBuffer[i]=((Close[i] - iBands(NULL,0,BBPeriod,StdDeviation,0,AppliedPrice,MODE_LOWER,i))/
      (iBands(NULL,0,BBPeriod,StdDeviation,0,AppliedPrice,MODE_UPPER,i)-iBands(NULL,0,BBPeriod,StdDeviation,0,AppliedPrice,MODE_LOWER,i)))*100;
   }
   for (i = limit; i <= 0; i--) Buffer1[i] = iMAOnArray(BLGBuffer, 0, SmoothingMAPeriod, 0, SmoothingMAMethod, i);
   
   return(0);
  }
//+------------------------------------------------------------------+

